diff --git a/saotk/util/tkCanvPsScaled.c b/saotk/util/tkCanvPsScaled.c
new file mode 100644
index 0000000..6214c20
--- /dev/null
+++ b/saotk/util/tkCanvPsScaled.c
@@ -0,0 +1,686 @@
+/*
+ * tkCanvPs.c --
+ *
+ *	This module provides Postscript output support for canvases, including
+ *	the "postscript" widget command plus a few utility functions used for
+ *	generating Postscript.
+ *
+ * Copyright (c) 1991-1994 The Regents of the University of California.
+ * Copyright (c) 1994-1997 Sun Microsystems, Inc.
+ *
+ * See the file "license.terms" for information on usage and redistribution of
+ * this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ *
+ * RCS: @(#) $Id: tkCanvPs.c,v 1.2 2011/07/26 21:07:34 joye Exp $
+ */
+/*
+ * This contains an override for saotk that allows scaling */
+
+#include "tkInt.h"
+#include "tkCanvas.h"
+
+/*** waj ***/
+float psScale =1;
+/*** waj ***/
+
+/*
+ * See tkCanvas.h for key data structures used to implement canvases.
+ */
+
+
+/*
+ * One of the following structures is created to keep track of Postscript
+ * output being generated. It consists mostly of information provided on the
+ * widget command line.
+ */
+
+typedef struct TkPostscriptInfo {
+    Tk_Window tkwin;		/* The canvas being printed. */
+    int x, y, width, height;	/* Area to print, in canvas pixel
+				 * coordinates. */
+    int x2, y2;			/* x+width and y+height. */
+    char *pageXString;		/* String value of "-pagex" option or NULL. */
+    char *pageYString;		/* String value of "-pagey" option or NULL. */
+    double pageX, pageY;	/* Postscript coordinates (in points)
+				 * corresponding to pageXString and
+				 * pageYString. Don't forget that y-values
+				 * grow upwards for Postscript! */
+    char *pageWidthString;	/* Printed width of output. */
+    char *pageHeightString;	/* Printed height of output. */
+    double scale;		/* Scale factor for conversion: each pixel
+				 * maps into this many points. */
+    Tk_Anchor pageAnchor;	/* How to anchor bbox on Postscript page. */
+    int rotate;			/* Non-zero means output should be rotated on
+				 * page (landscape mode). */
+    char *fontVar;		/* If non-NULL, gives name of global variable
+				 * containing font mapping information.
+				 * Malloc'ed. */
+    char *colorVar;		/* If non-NULL, give name of global variable
+				 * containing color mapping information.
+				 * Malloc'ed. */
+    char *colorMode;		/* Mode for handling colors: "monochrome",
+				 * "gray", or "color".  Malloc'ed. */
+    int colorLevel;		/* Numeric value corresponding to colorMode: 0
+				 * for mono, 1 for gray, 2 for color. */
+    char *fileName;		/* Name of file in which to write Postscript;
+				 * NULL means return Postscript info as
+				 * result. Malloc'ed. */
+    char *channelName;		/* If -channel is specified, the name of the
+                                 * channel to use. */
+    Tcl_Channel chan;		/* Open channel corresponding to fileName. */
+    Tcl_HashTable fontTable;	/* Hash table containing names of all font
+				 * families used in output. The hash table
+				 * values are not used. */
+    int prepass;		/* Non-zero means that we're currently in the
+				 * pre-pass that collects font information, so
+				 * the Postscript generated isn't relevant. */
+    int prolog;			/* Non-zero means output should contain the
+				 * prolog definitions in the header. */
+} TkPostscriptInfo;
+
+/*
+ * The table below provides a template that's used to process arguments to the
+ * canvas "postscript" command and fill in TkPostscriptInfo structures.
+ */
+
+static Tk_ConfigSpec configSpecs[] = {
+    {TK_CONFIG_STRING, "-colormap", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, colorVar), 0},
+    {TK_CONFIG_STRING, "-colormode", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, colorMode), 0},
+    {TK_CONFIG_STRING, "-file", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, fileName), 0},
+    {TK_CONFIG_STRING, "-channel", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, channelName), 0},
+    {TK_CONFIG_STRING, "-fontmap", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, fontVar), 0},
+    {TK_CONFIG_PIXELS, "-height", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, height), 0},
+    {TK_CONFIG_ANCHOR, "-pageanchor", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, pageAnchor), 0},
+    {TK_CONFIG_STRING, "-pageheight", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, pageHeightString), 0},
+    {TK_CONFIG_STRING, "-pagewidth", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, pageWidthString), 0},
+    {TK_CONFIG_STRING, "-pagex", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, pageXString), 0},
+    {TK_CONFIG_STRING, "-pagey", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, pageYString), 0},
+    {TK_CONFIG_BOOLEAN, "-prolog", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, prolog), 0},
+    {TK_CONFIG_BOOLEAN, "-rotate", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, rotate), 0},
+    {TK_CONFIG_PIXELS, "-width", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, width), 0},
+    {TK_CONFIG_PIXELS, "-x", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, x), 0},
+    {TK_CONFIG_PIXELS, "-y", NULL, NULL,
+	"", Tk_Offset(TkPostscriptInfo, y), 0},
+    {TK_CONFIG_END, NULL, NULL, NULL, NULL, 0, 0}
+};
+
+/*
+ * Forward declarations for functions defined later in this file:
+ */
+
+static int		GetPostscriptPoints(Tcl_Interp *interp,
+			    char *string, double *doublePtr);
+
+/*
+ *--------------------------------------------------------------
+ *
+ * TkCanvPostscriptCmd --
+ *
+ *	This function is invoked to process the "postscript" options of the
+ *	widget command for canvas widgets. See the user documentation for
+ *	details on what it does.
+ *
+ * Results:
+ *	A standard Tcl result.
+ *
+ * Side effects:
+ *	See the user documentation.
+ *
+ *--------------------------------------------------------------
+ */
+
+    /* ARGSUSED */
+int
+TkCanvPostscriptCmd(
+    TkCanvas *canvasPtr,	/* Information about canvas widget. */
+    Tcl_Interp *interp,		/* Current interpreter. */
+    int argc,			/* Number of arguments. */
+    CONST char **argv)		/* Argument strings. Caller has already parsed
+				 * this command enough to know that argv[1] is
+				 * "postscript". */
+{
+    TkPostscriptInfo psInfo, *psInfoPtr = &psInfo;
+    Tk_PostscriptInfo oldInfoPtr;
+    int result;
+    Tk_Item *itemPtr;
+#define STRING_LENGTH 400
+    char string[STRING_LENGTH+1];
+    CONST char *p;
+    time_t now;
+    size_t length;
+    Tk_Window tkwin = canvasPtr->tkwin;
+    Tcl_HashSearch search;
+    Tcl_HashEntry *hPtr;
+    Tcl_DString buffer;
+    char psenccmd[] = "::tk::ensure_psenc_is_loaded";
+    int deltaX = 0, deltaY = 0;	/* Offset of lower-left corner of area to be
+				 * marked up, measured in canvas units from
+				 * the positioning point on the page (reflects
+				 * anchor position). Initial values needed
+				 * only to stop compiler warnings. */
+
+    /*
+     * Initialize the data structure describing Postscript generation, then
+     * process all the arguments to fill the data structure in.
+     */
+
+    result = Tcl_EvalEx(interp,psenccmd,-1,TCL_EVAL_GLOBAL);
+    if (result != TCL_OK) {
+        return result;
+    }
+    oldInfoPtr = canvasPtr->psInfo;
+    canvasPtr->psInfo = (Tk_PostscriptInfo) psInfoPtr;
+    psInfo.tkwin = canvasPtr->tkwin;
+    psInfo.x = canvasPtr->xOrigin;
+    psInfo.y = canvasPtr->yOrigin;
+    psInfo.width = -1;
+    psInfo.height = -1;
+    psInfo.pageXString = NULL;
+    psInfo.pageYString = NULL;
+    psInfo.pageX = 72*4.25;
+    psInfo.pageY = 72*5.5;
+    psInfo.pageWidthString = NULL;
+    psInfo.pageHeightString = NULL;
+    psInfo.scale = 1.0;
+    psInfo.pageAnchor = TK_ANCHOR_CENTER;
+    psInfo.rotate = 0;
+    psInfo.fontVar = NULL;
+    psInfo.colorVar = NULL;
+    psInfo.colorMode = NULL;
+    psInfo.colorLevel = 0;
+    psInfo.fileName = NULL;
+    psInfo.channelName = NULL;
+    psInfo.chan = NULL;
+    psInfo.prepass = 0;
+    psInfo.prolog = 1;
+    Tcl_InitHashTable(&psInfo.fontTable, TCL_STRING_KEYS);
+    result = Tk_ConfigureWidget(interp, tkwin, configSpecs, argc-2, argv+2,
+	    (char *) &psInfo, TK_CONFIG_ARGV_ONLY);
+    if (result != TCL_OK) {
+	goto cleanup;
+    }
+
+    if (psInfo.width == -1) {
+	psInfo.width = Tk_Width(tkwin);
+    }
+    if (psInfo.height == -1) {
+	psInfo.height = Tk_Height(tkwin);
+    }
+    psInfo.x2 = psInfo.x + psInfo.width;
+    psInfo.y2 = psInfo.y + psInfo.height;
+
+    if (psInfo.pageXString != NULL) {
+	if (GetPostscriptPoints(interp, psInfo.pageXString,
+		&psInfo.pageX) != TCL_OK) {
+	    goto cleanup;
+	}
+    }
+    if (psInfo.pageYString != NULL) {
+	if (GetPostscriptPoints(interp, psInfo.pageYString,
+		&psInfo.pageY) != TCL_OK) {
+	    goto cleanup;
+	}
+    }
+    if (psInfo.pageWidthString != NULL) {
+	if (GetPostscriptPoints(interp, psInfo.pageWidthString,
+		&psInfo.scale) != TCL_OK) {
+	    goto cleanup;
+	}
+	psInfo.scale /= psInfo.width;
+    } else if (psInfo.pageHeightString != NULL) {
+	if (GetPostscriptPoints(interp, psInfo.pageHeightString,
+		&psInfo.scale) != TCL_OK) {
+	    goto cleanup;
+	}
+	psInfo.scale /= psInfo.height;
+    } else {
+	psInfo.scale = (72.0/25.4)*WidthMMOfScreen(Tk_Screen(tkwin));
+	psInfo.scale /= WidthOfScreen(Tk_Screen(tkwin));
+    }
+    switch (psInfo.pageAnchor) {
+    case TK_ANCHOR_NW:
+    case TK_ANCHOR_W:
+    case TK_ANCHOR_SW:
+	deltaX = 0;
+	break;
+    case TK_ANCHOR_N:
+    case TK_ANCHOR_CENTER:
+    case TK_ANCHOR_S:
+	deltaX = -psInfo.width/2;
+	break;
+    case TK_ANCHOR_NE:
+    case TK_ANCHOR_E:
+    case TK_ANCHOR_SE:
+	deltaX = -psInfo.width;
+	break;
+    }
+    switch (psInfo.pageAnchor) {
+    case TK_ANCHOR_NW:
+    case TK_ANCHOR_N:
+    case TK_ANCHOR_NE:
+	deltaY = - psInfo.height;
+	break;
+    case TK_ANCHOR_W:
+    case TK_ANCHOR_CENTER:
+    case TK_ANCHOR_E:
+	deltaY = -psInfo.height/2;
+	break;
+    case TK_ANCHOR_SW:
+    case TK_ANCHOR_S:
+    case TK_ANCHOR_SE:
+	deltaY = 0;
+	break;
+    }
+
+    if (psInfo.colorMode == NULL) {
+	psInfo.colorLevel = 2;
+    } else {
+	length = strlen(psInfo.colorMode);
+	if (strncmp(psInfo.colorMode, "monochrome", length) == 0) {
+	    psInfo.colorLevel = 0;
+	} else if (strncmp(psInfo.colorMode, "gray", length) == 0) {
+	    psInfo.colorLevel = 1;
+	} else if (strncmp(psInfo.colorMode, "color", length) == 0) {
+	    psInfo.colorLevel = 2;
+	} else {
+	    Tcl_AppendResult(interp, "bad color mode \"", psInfo.colorMode,
+		    "\": must be monochrome, gray, or color", NULL);
+	    goto cleanup;
+	}
+    }
+
+    if (psInfo.fileName != NULL) {
+        /*
+         * Check that -file and -channel are not both specified.
+         */
+
+        if (psInfo.channelName != NULL) {
+            Tcl_AppendResult(interp, "can't specify both -file",
+                    " and -channel", NULL);
+            result = TCL_ERROR;
+            goto cleanup;
+        }
+
+        /*
+         * Check that we are not in a safe interpreter. If we are, disallow
+         * the -file specification.
+         */
+
+        if (Tcl_IsSafe(interp)) {
+            Tcl_AppendResult(interp, "can't specify -file in a",
+                    " safe interpreter", NULL);
+            result = TCL_ERROR;
+            goto cleanup;
+        }
+
+	p = Tcl_TranslateFileName(interp, psInfo.fileName, &buffer);
+	if (p == NULL) {
+	    goto cleanup;
+	}
+	psInfo.chan = Tcl_OpenFileChannel(interp, p, "w", 0666);
+	Tcl_DStringFree(&buffer);
+	if (psInfo.chan == NULL) {
+	    goto cleanup;
+	}
+    }
+
+    if (psInfo.channelName != NULL) {
+        int mode;
+
+        /*
+         * Check that the channel is found in this interpreter and that it is
+         * open for writing.
+         */
+
+        psInfo.chan = Tcl_GetChannel(interp, psInfo.channelName, &mode);
+        if (psInfo.chan == (Tcl_Channel) NULL) {
+            result = TCL_ERROR;
+            goto cleanup;
+        }
+        if ((mode & TCL_WRITABLE) == 0) {
+            Tcl_AppendResult(interp, "channel \"", psInfo.channelName,
+		    "\" wasn't opened for writing", NULL);
+            result = TCL_ERROR;
+            goto cleanup;
+        }
+    }
+
+    /*
+     * Make a pre-pass over all of the items, generating Postscript and then
+     * throwing it away. The purpose of this pass is just to collect
+     * information about all the fonts in use, so that we can output font
+     * information in the proper form required by the Document Structuring
+     * Conventions.
+     */
+
+    psInfo.prepass = 1;
+    for (itemPtr = canvasPtr->firstItemPtr; itemPtr != NULL;
+	    itemPtr = itemPtr->nextPtr) {
+	if ((itemPtr->x1 >= psInfo.x2) || (itemPtr->x2 < psInfo.x)
+		|| (itemPtr->y1 >= psInfo.y2) || (itemPtr->y2 < psInfo.y)) {
+	    continue;
+	}
+	if (itemPtr->typePtr->postscriptProc == NULL) {
+	    continue;
+	}
+	result = (*itemPtr->typePtr->postscriptProc)(interp,
+		(Tk_Canvas) canvasPtr, itemPtr, 1);
+	Tcl_ResetResult(interp);
+	if (result != TCL_OK) {
+	    /*
+	     * An error just occurred. Just skip out of this loop. There's no
+	     * need to report the error now; it can be reported later (errors
+	     * can happen later that don't happen now, so we still have to
+	     * check for errors later anyway).
+	     */
+	    break;
+	}
+    }
+    psInfo.prepass = 0;
+
+    /*
+     * Generate the header and prolog for the Postscript.
+     */
+
+    if (psInfo.prolog) {
+	Tcl_AppendResult(interp, "%!PS-Adobe-3.0 EPSF-3.0\n",
+		"%%Creator: Tk Canvas Widget\n", NULL);
+#ifdef HAVE_PW_GECOS
+	if (!Tcl_IsSafe(interp)) {
+	    struct passwd *pwPtr = getpwuid(getuid());	/* INTL: Native. */
+
+	    Tcl_AppendResult(interp, "%%For: ",
+		    (pwPtr != NULL) ? pwPtr->pw_gecos : "Unknown", "\n", NULL);
+	    endpwent();
+	}
+#endif /* HAVE_PW_GECOS */
+	Tcl_AppendResult(interp, "%%Title: Window ", Tk_PathName(tkwin), "\n",
+		NULL);
+	time(&now);
+	Tcl_AppendResult(interp, "%%CreationDate: ",
+		ctime(&now), NULL);		/* INTL: Native. */
+	if (!psInfo.rotate) {
+	    sprintf(string, "%d %d %d %d",
+		    (int) (psInfo.pageX + psInfo.scale*deltaX),
+		    (int) (psInfo.pageY + psInfo.scale*deltaY),
+		    (int) (psInfo.pageX + psInfo.scale*(deltaX + psInfo.width)
+			    + 1.0),
+		    (int) (psInfo.pageY + psInfo.scale*(deltaY + psInfo.height)
+			    + 1.0));
+	} else {
+	    sprintf(string, "%d %d %d %d",
+		    (int) (psInfo.pageX - psInfo.scale*(deltaY+psInfo.height)),
+		    (int) (psInfo.pageY + psInfo.scale*deltaX),
+		    (int) (psInfo.pageX - psInfo.scale*deltaY + 1.0),
+		    (int) (psInfo.pageY + psInfo.scale*(deltaX + psInfo.width)
+			    + 1.0));
+	}
+	Tcl_AppendResult(interp, "%%BoundingBox: ", string, "\n", NULL);
+	Tcl_AppendResult(interp, "%%Pages: 1\n",
+		"%%DocumentData: Clean7Bit\n", NULL);
+	Tcl_AppendResult(interp, "%%Orientation: ",
+		psInfo.rotate ? "Landscape\n" : "Portrait\n", NULL);
+	p = "%%DocumentNeededResources: font ";
+	for (hPtr = Tcl_FirstHashEntry(&psInfo.fontTable, &search);
+		hPtr != NULL; hPtr = Tcl_NextHashEntry(&search)) {
+	    Tcl_AppendResult(interp, p,
+		    Tcl_GetHashKey(&psInfo.fontTable, hPtr), "\n", NULL);
+	    p = "%%+ font ";
+	}
+	Tcl_AppendResult(interp, "%%EndComments\n\n", NULL);
+
+	/*
+	 * Insert the prolog
+	 */
+
+	Tcl_AppendResult(interp, Tcl_GetVar(interp,"::tk::ps_preamable",
+		TCL_GLOBAL_ONLY), NULL);
+
+	if (psInfo.chan != NULL) {
+	    Tcl_Write(psInfo.chan, Tcl_GetStringResult(interp), -1);
+	    Tcl_ResetResult(canvasPtr->interp);
+	}
+
+	/*
+	 * Document setup:  set the color level and include fonts.
+	 */
+
+	sprintf(string, "/CL %d def\n", psInfo.colorLevel);
+	Tcl_AppendResult(interp, "%%BeginSetup\n", string, NULL);
+	for (hPtr = Tcl_FirstHashEntry(&psInfo.fontTable, &search);
+		hPtr != NULL; hPtr = Tcl_NextHashEntry(&search)) {
+	    Tcl_AppendResult(interp, "%%IncludeResource: font ",
+		    Tcl_GetHashKey(&psInfo.fontTable, hPtr), "\n", NULL);
+	}
+	Tcl_AppendResult(interp, "%%EndSetup\n\n", NULL);
+
+	/*
+	 * Page setup: move to page positioning point, rotate if needed, set
+	 * scale factor, offset for proper anchor position, and set clip
+	 * region.
+	 */
+
+	Tcl_AppendResult(interp, "%%Page: 1 1\n", "save\n", NULL);
+	sprintf(string, "%.1f %.1f translate\n", psInfo.pageX, psInfo.pageY);
+	Tcl_AppendResult(interp, string, NULL);
+	if (psInfo.rotate) {
+	    Tcl_AppendResult(interp, "90 rotate\n", NULL);
+	}
+	sprintf(string, "%.4g %.4g scale\n", psInfo.scale, psInfo.scale);
+	Tcl_AppendResult(interp, string, NULL);
+	sprintf(string, "%d %d translate\n", deltaX - psInfo.x, deltaY);
+	Tcl_AppendResult(interp, string, NULL);
+	sprintf(string,
+		"%d %.15g moveto %d %.15g lineto %d %.15g lineto %d %.15g",
+		psInfo.x, Tk_PostscriptY((double)psInfo.y,
+			(Tk_PostscriptInfo)psInfoPtr),
+		psInfo.x2, Tk_PostscriptY((double)psInfo.y,
+			(Tk_PostscriptInfo)psInfoPtr),
+		psInfo.x2, Tk_PostscriptY((double)psInfo.y2,
+			(Tk_PostscriptInfo)psInfoPtr),
+		psInfo.x, Tk_PostscriptY((double)psInfo.y2,
+			(Tk_PostscriptInfo)psInfoPtr));
+	Tcl_AppendResult(interp, string,
+		" lineto closepath clip newpath\n", NULL);
+    }
+    /*** waj ***/
+    sprintf(string, "%g %g translate\n",
+ 	    (Tk_PostscriptY((double) psInfo.x, (Tk_PostscriptInfo) &psInfo) -
+ 	     Tk_PostscriptY((double) psInfo.x2, (Tk_PostscriptInfo) &psInfo))
+ 	    *(1.-psScale)/2.,
+ 	    (Tk_PostscriptY((double) psInfo.y, (Tk_PostscriptInfo) &psInfo) -
+ 	     Tk_PostscriptY((double) psInfo.y2, (Tk_PostscriptInfo) &psInfo)) 
+ 	    *(1.-psScale)/2.);
+    Tcl_AppendResult(interp, string, (char *) NULL);
+ 
+    sprintf(string, "%.4g %.4g scale\n", psScale, psScale);
+    Tcl_AppendResult(interp, string, (char *) NULL);
+    /*** waj ***/
+    if (psInfo.chan != NULL) {
+	Tcl_Write(psInfo.chan, Tcl_GetStringResult(interp), -1);
+	Tcl_ResetResult(canvasPtr->interp);
+    }
+
+    /*
+     * Iterate through all the items, having each relevant one draw itself.
+     * Quit if any of the items returns an error.
+     */
+
+    result = TCL_OK;
+    for (itemPtr = canvasPtr->firstItemPtr; itemPtr != NULL;
+	    itemPtr = itemPtr->nextPtr) {
+	if ((itemPtr->x1 >= psInfo.x2) || (itemPtr->x2 < psInfo.x)
+		|| (itemPtr->y1 >= psInfo.y2) || (itemPtr->y2 < psInfo.y)) {
+	    continue;
+	}
+	if (itemPtr->typePtr->postscriptProc == NULL) {
+	    continue;
+	}
+	if (itemPtr->state == TK_STATE_HIDDEN) {
+	    continue;
+	}
+	Tcl_AppendResult(interp, "gsave\n", NULL);
+	result = (*itemPtr->typePtr->postscriptProc)(interp,
+		(Tk_Canvas) canvasPtr, itemPtr, 0);
+	if (result != TCL_OK) {
+	    char msg[64 + TCL_INTEGER_SPACE];
+
+	    sprintf(msg, "\n    (generating Postscript for item %d)",
+		    itemPtr->id);
+	    Tcl_AddErrorInfo(interp, msg);
+	    goto cleanup;
+	}
+	Tcl_AppendResult(interp, "grestore\n", NULL);
+	if (psInfo.chan != NULL) {
+	    Tcl_Write(psInfo.chan, Tcl_GetStringResult(interp), -1);
+	    Tcl_ResetResult(interp);
+	}
+    }
+
+    /*
+     * Output page-end information, such as commands to print the page and
+     * document trailer stuff.
+     */
+
+    if (psInfo.prolog) {
+	Tcl_AppendResult(interp, "restore showpage\n\n",
+		"%%Trailer\nend\n%%EOF\n", NULL);
+    }
+    if (psInfo.chan != NULL) {
+	Tcl_Write(psInfo.chan, Tcl_GetStringResult(interp), -1);
+	Tcl_ResetResult(canvasPtr->interp);
+    }
+
+    /*
+     * Clean up psInfo to release malloc'ed stuff.
+     */
+
+  cleanup:
+    if (psInfo.pageXString != NULL) {
+	ckfree(psInfo.pageXString);
+    }
+    if (psInfo.pageYString != NULL) {
+	ckfree(psInfo.pageYString);
+    }
+    if (psInfo.pageWidthString != NULL) {
+	ckfree(psInfo.pageWidthString);
+    }
+    if (psInfo.pageHeightString != NULL) {
+	ckfree(psInfo.pageHeightString);
+    }
+    if (psInfo.fontVar != NULL) {
+	ckfree(psInfo.fontVar);
+    }
+    if (psInfo.colorVar != NULL) {
+	ckfree(psInfo.colorVar);
+    }
+    if (psInfo.colorMode != NULL) {
+	ckfree(psInfo.colorMode);
+    }
+    if (psInfo.fileName != NULL) {
+	ckfree(psInfo.fileName);
+    }
+    if ((psInfo.chan != NULL) && (psInfo.channelName == NULL)) {
+	Tcl_Close(interp, psInfo.chan);
+    }
+    if (psInfo.channelName != NULL) {
+        ckfree(psInfo.channelName);
+    }
+    Tcl_DeleteHashTable(&psInfo.fontTable);
+    canvasPtr->psInfo = (Tk_PostscriptInfo) oldInfoPtr;
+    return result;
+}
+
+/*
+ *--------------------------------------------------------------
+ *
+ * GetPostscriptPoints --
+ *
+ *	Given a string, returns the number of Postscript points corresponding
+ *	to that string.
+ *
+ * Results:
+ *	The return value is a standard Tcl return result. If TCL_OK is
+ *	returned, then everything went well and the screen distance is stored
+ *	at *doublePtr; otherwise TCL_ERROR is returned and an error message is
+ *	left in the interp's result.
+ *
+ * Side effects:
+ *	None.
+ *
+ *--------------------------------------------------------------
+ */
+
+static int
+GetPostscriptPoints(
+    Tcl_Interp *interp,		/* Use this for error reporting. */
+    char *string,		/* String describing a screen distance. */
+    double *doublePtr)		/* Place to store converted result. */
+{
+    char *end;
+    double d;
+
+    d = strtod(string, &end);
+    if (end == string) {
+	goto error;
+    }
+    while ((*end != '\0') && isspace(UCHAR(*end))) {
+	end++;
+    }
+    switch (*end) {
+    case 'c':
+	d *= 72.0/2.54;
+	end++;
+	break;
+    case 'i':
+	d *= 72.0;
+	end++;
+	break;
+    case 'm':
+	d *= 72.0/25.4;
+	end++;
+	break;
+    case 0:
+	break;
+    case 'p':
+	end++;
+	break;
+    default:
+	goto error;
+    }
+    while ((*end != '\0') && isspace(UCHAR(*end))) {
+	end++;
+    }
+    if (*end != 0) {
+	goto error;
+    }
+    *doublePtr = d;
+    return TCL_OK;
+
+  error:
+    Tcl_AppendResult(interp, "bad distance \"", string, "\"", NULL);
+    return TCL_ERROR;
+}
+
+/*
+ * Local Variables:
+ * mode: c
+ * c-basic-offset: 4
+ * fill-column: 78
+ * End:
+ */
